' Declares for Visual Basic
' PPDF library
Declare Function PPDF_Init Lib "ppdf.dll" () As Long
Declare Function PPDF_Done Lib "ppdf.dll" (ByVal pPdf As Long) As Long
Declare Function PPDF_StartPage Lib "ppdf.dll" (ByVal pPdf As Long) As Long
Declare Function PPDF_EndPage Lib "ppdf.dll" (ByVal pPdf As Long) As Long
Declare Function PPDF_WriteFile Lib "ppdf.dll" (ByVal pPdf As Long, ByVal filename As String) As Long
Declare Function PPDF_AppendData Lib "ppdf.dll" (ByVal pPdf As Long, ByVal text As String) As Long
Declare Function PPDF_SetFont Lib "PPDF.dll" Alias "PPDF_SetFont" (ByVal pPDF as Long, ByVal iFont as Long, ByVal iSize as Long) As Long
Declare Function PPDF_EmitColor Lib "ppdf.dll" (ByVal pPdf As Long, ByVal color As Long) As Long
Declare Function PPDF_EmitColorRGB Lib "ppdf.dll" (ByVal pPdf As Long, ByVal r As Long, ByVal g As Long, ByVal b As Long) As Long
Declare Function PPDF_EmitText Lib "ppdf.dll" (ByVal pPdf As Long, ByVal text As String, ByVal slen As Long) As Long
'Declare Function PPDF_EmitTextBox Lib "PPDF.dll" Alias "PPDF_EmitTextBox" (ByVal pPDF as Long, ByVal x as Long, ByVal y as Long, ByVal pchText as String, ByVal cchText as Long) As Long
Declare Function PPDF_EmitTextBox Lib "PPDF.dll" Alias "PPDF_EmitTextBox" (ByVal pPDF as Long, ByVal x as Long, ByVal y as Long, ByVal pchText as String) As Long
Declare Function PPDF_EmitStrokeColorRGB Lib "ppdf.dll" (ByVal pPdf As Long, ByVal r As Long, ByVal g As Long, ByVal b As Long) As Long
Declare Function PPDF_EmitMoveTo Lib "ppdf.dll" (ByVal pPdf As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function PPDF_EmitLineTo Lib "ppdf.dll" (ByVal pPdf As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function PPDF_EmitLineEnd Lib "ppdf.dll" (ByVal pPdf As Long) As Long
Declare Function PPDF_EmitRect Lib "ppdf.dll" (ByVal pPdf As Long, ByVal x As Long, ByVal y As Long, ByVal w As Long, ByVal h As Long) As Long
Declare Function PPDF_EmitCircle Lib "ppdf.dll" (ByVal pPdf As Long, ByVal x As Long, ByVal y As Long, ByVal r As Long) As Long
Declare Function PPDF_EmitCurveTo Lib "ppdf.dll" (ByVal pPdf As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal x3 As Long, ByVal y3 As Long) As Long
Declare Function PPDF_EmitLineWidth Lib "ppdf.dll" (ByVal pPdf As Long, ByVal w As Long) As Long
Declare Function PPDF_Compress Lib "ppdf.dll" (ByVal pPdf As Long, ByVal comp As Long) As Long

Sub PPDF_Test()
Dim pPdf, pObj
    pPdf = PPDF_Init()
    If pPdf Then
        'PDF_Compress pPdf, 0
        ' Start new page.
        pObj = PPDF_StartPage(pPdf)
        If pObj Then
            For i = 1 To 2
                PPDF_EmitColor pPdf, i
                PPDF_EmitText pPdf, "Hello", 5
            Next
            PPDF_EndPage (pPdf)
            If PPDF_WriteFile(pPdf, "PPDF_TestX.pdf") Then
                MsgBox ("Error")
            End If
        End If
        PPDF_Done pPdf
    End If
End Sub

Sub Main()
    Dim pPdf
    pPdf = PPDF_Init()
    If pPdf Then
        If PPDF_StartPage(pPdf) Then
            If PPDF_EmitRect(pPdf, 20, 20, 500, 500) < 0 Then Goto InError
            If PPDF_EmitCircle(pPdf, 200, 200, 150) < 0 Then Goto InError
            ' SetFont iFontNumber only 1
            ' iFontSize 1 -72, 0 doesn't change anything
            If PPDF_SetFont(pPdf, 0, 24) < 0 Then Goto InError
            If PPDF_EmitTextBox(pPdf, 25, 25, "Page:") < 0 Then Goto InError
            If PPDF_EndPage(pPdf) < 0 Then Goto InError
            If PPDF_WriteFile(pPdf, "c:\PPDF_TestX.pdf") Then
                MsgBox ("Error")
            End If
        End If
InError:
        PPDF_Done pPdf
    End If
End Sub


