
/*
--  gePPDF.g  v 1 (25.04.2006)  
--     PDF 
--   
*/

 

import "ppdf.dll"
{
	//PPDFFILE PPDFAPI PPDF_Init(void);
	uint PPDF_Init();
	//void PPDFAPI PPDF_Done(PPDFFILE);
	PPDF_Done(uint);
	//PPDFOBJ PPDFAPI PPDF_NewObject(PPDFFILE, PPDF_TYPE);
	uint PPDF_NewObject(uint,uint);
	//PPDFOBJ PPDFAPI PPDF_FindObject(PPDFOBJ, PPDF_TYPE);
	uint PPDF_FindObject(uint,uint);
	//int PPDFAPI PPDF_AppendDataObj(PPDFOBJ, PCSTR);
	uint PPDF_AppendDataObj(uint,uint );
	//int PPDFAPI PPDF_AppendData(PPDFFILE, PCSTR);
	uint PPDF_AppendData(uint, uint);
 	//PPDFOBJ PPDFAPI PPDF_StartPage(PPDFFILE);
	uint PPDF_StartPage(uint);
	//int PPDFAPI PPDF_EndPage(PPDFFILE);
	uint PPDF_EndPage(uint);
	//int PPDFAPI PPDF_SetFont(PPDFFILE pPDF, int iFont, int iSize);
	uint PPDF_SetFont(uint,uint,uint);
	//int PPDFAPI PPDF_SetFontAngle(PPDFFILE pPDF, int iAngle);
	uint PPDF_SetFontAngle(uint,uint);
	//int PPDFAPI PPDF_NewLine(PPDFFILE);
	uint PPDF_NewLine(uint);
	//int PPDFAPI PPDF_WriteFile(PPDFFILE, PCSTR);
	uint PPDF_WriteFile(uint,uint);
	//int PPDFAPI PPDF_EmitText(PPDFFILE, PCSTR, int);
	uint PPDF_EmitText(uint,uint, uint);
	//int PPDFAPI PPDF_EmitTextBox(PPDFFILE pPDF, int x, int y, PCSTR pchText);
	uint PPDF_EmitTextBox(uint, uint, uint ,uint);
	//int PPDFAPI PPDF_EmitTextPos(PPDFFILE pPDF, int x, int y);
	//int PPDFAPI PPDF_EmitColor(PPDFFILE, int);
	uint PPDF_EmitColor(uint, uint);
	//int PPDFAPI PPDF_EmitColorRGB(PPDFFILE pPDF, int r, int g, int b);
	uint PPDF_EmitColorRGB(uint, uint, uint , uint );
	//int PPDFAPI PPDF_EmitStrokeColorRGB(PPDFFILE pPDF, int r, int g, int b);
	uint PPDF_EmitStrokeColorRGB(uint, uint , uint , uint );
	//int PPDFAPI PPDF_EmitMoveTo(PPDFFILE pPDF, int x, int y);
	uint PPDF_EmitMoveTo(uint, uint , uint );
	//int PPDFAPI PPDF_EmitLineTo(PPDFFILE pPDF, int x, int y);
	uint PPDF_EmitLineTo(uint, uint , uint );
	//int PPDFAPI PPDF_EmitLineEnd(PPDFFILE pPDF);
	uint PPDF_EmitLineEnd(uint);
	//int PPDFAPI PPDF_EmitRect(PPDFFILE pPDF, int x, int y, int w, int h);
	uint PPDF_EmitRect(uint, uint , uint , uint , uint );
	//int PPDFAPI PPDF_EmitCircle(PPDFFILE pPDF, int x, int y, int r);
	uint PPDF_EmitCircle(uint, uint , uint , uint );
	//int PPDFAPI PPDF_EmitCurveTo(PPDFFILE pPDF, int x1, int y1, int x2, int y2, int x3, int y3);
	uint PPDF_EmitCurveTo(uint, uint , uint , uint , uint , uint , uint );
	//int PPDFAPI PPDF_EmitLineWidth(PPDFFILE pPDF, int w);
	uint PPDF_EmitLineWidth(uint, uint);
	//int PPDFAPI PPDF_Compress(PPDFFILE pPDF, int iComp);
	uint PPDF_Compress(uint, uint);
}

global 
{
 arr  error_code of str = %{"Ok", "Error PDF stream", "Error initialize  Page","Error close page","Error write PDF file",
 "Error insert new line","Error write text on the page","Error change text color","Error move cursor position",
 "Error draw line","Error set end line","Error draw rectangle","Error draw circle"}
}

type PPDF
{
  uint PPDFFILE;
  uint iErrorCode;
  str sErrorMessage;
}
/*
--     
--   Parameters:
--              
------------------
--   return:      
-- 
*/
method byte PPDF.getErrorCode()
{
   return this.iErrorCode; 
}
/*
--     
--   Parameters:
--              
------------------
--   return:      
-- 
*/
method str PPDF.getErrorMessage()
{
   return error_code[this.iErrorCode]; 
}

/*
--   ()  PDF 
--   Parameters:
--              
------------------
--   return iErrorCode. 0 -       
-- 
*/

method  PPDF.Create()
{
   this.PPDFFILE = PPDF_Init()
	if (this.PPDFFILE != 0)	{
	  this.iErrorCode = 0;
	}
	else {
	 this.iErrorCode = 1;
	}
}
/*
--   ()  PDF 
--   Parameters:
--              
------------------
--   return     
-- 
*/
method PPDF.Release()
{
   PPDF_Done(this.PPDFFILE)
}
/*
--    PDF 
--   Parameters:
--              
------------------
--   return iErrorCode. 0 -       
-- 
*/

method uint PPDF.StartPage()
{
	this.iErrorCode = 0;
 	if (PPDF_StartPage(this.PPDFFILE) == 0) {
	  this.iErrorCode = 2;
	}
	return this.iErrorCode;
}
/*
--   ,  
--   Parameters:
--              
------------------
--   return iErrorCode. 3 -     
-- 
*/

method uint PPDF.EndPage()
{
	this.iErrorCode = 0;
 	if (PPDF_EndPage(this.PPDFFILE) < 0) {
	  this.iErrorCode = 3;
	}
	return this.iErrorCode; 
}
/*
--         
--   Parameters:
--          sNameFile		-   ( )    
------------------
--   return iErrorCode. 0 -     ,4 -    
-- 
*/

method uint PPDF.WritePdf(str sNameFile)
{
  this.iErrorCode = 0;
  if (PPDF_WriteFile(this.PPDFFILE,sNameFile.ptr()) < 0)
	{
	  this.iErrorCode = 4;	
	}
	return this.iErrorCode;
}

/*
--       
--   Parameters:
--              
------------------
--   return iErrorCode. 0 -    ,5 -    
-- 
*/

method uint PPDF.NewLine()
{
  this.iErrorCode = 0;
  if (PPDF_NewLine(this.PPDFFILE) < 0)
	{
	  this.iErrorCode = 5;	
	}
	return this.iErrorCode;
}

/*
--        
--   Parameters:
--				sText 		-  
--				iLenText 	-  ,  0,  -                  
------------------
--   return iErrorCode. 0 -   ,6 -    
-- 
*/

method uint PPDF.OutText(str sText,uint iLenText)
{
  uint lLen = iLenText;
  this.iErrorCode = 0;
  if (lLen == 0): lLen = *sText;  
  if (PPDF_EmitText(this.PPDFFILE,sText.ptr(),lLen) < 0)
	{
	  this.iErrorCode = 6;	
	}
	return this.iErrorCode;
}

/*
--       iX,iY 
--   Parameters:
--				sText 		-  
--				iX	 			- X   
--				iY 			- Y                  
------------------
--   return iErrorCode. 0 -   ,6 -    
-- 
*/

method uint PPDF.OutTextBox(str sText,uint iX,uint iY)
{
  this.iErrorCode = 0;
  if (PPDF_EmitTextBox(this.PPDFFILE,iX,iY,sText.ptr()) < 0)
	{
	  this.iErrorCode = 6;	
	}
	return this.iErrorCode;
}

/*
--       RGB() 
--   Parameters:
--				sText 		-  
--				iRed	 			-   
--				iGreen 			-   
--				iBlue 			-                  
------------------
--   return iErrorCode. 0 -   ,7 -    
-- 
*/

method uint PPDF.SetColorRGB(uint iRed,uint iGreen,uint iBlue)
{
  this.iErrorCode = 0;
  if (PPDF_EmitColorRGB(this.PPDFFILE,iRed,iGreen,iBlue) < 0)
	{
	  this.iErrorCode = 7;	
	}
	return this.iErrorCode;
}

/*
--      iX,iY 
--   Parameters:
--				iX	 			- X  
--				iY 			- Y                 
------------------
--   return iErrorCode. 0 -     ,8 -    
-- 
*/

method uint PPDF.MoveTo(uint iX,uint iY)
{
  this.iErrorCode = 0;
  if (PPDF_EmitMoveTo(this.PPDFFILE,iX,iY) < 0)
	{
	  this.iErrorCode = 8;	
	}
	return this.iErrorCode;
}

/*
--           iX,iY 
--   Parameters:
--				iX	 			- X    
--				iY 			- Y                  
------------------
--   return iErrorCode. 0 -   ,9 -    
-- 
*/

method uint PPDF.LineTo(uint iX,uint iY)
{
  this.iErrorCode = 0;
  if (PPDF_EmitLineTo(this.PPDFFILE,iX,iY) < 0)
	{
	  this.iErrorCode = 9;	
	}
	return this.iErrorCode;
}

/*
--     ,   
--   Parameters:
------------------
--   return iErrorCode. 0 -     ,10 -    
-- 
*/

method uint PPDF.LineEnd()
{
  this.iErrorCode = 0;
  if (PPDF_EmitLineEnd(this.PPDFFILE) < 0)
	{
	  this.iErrorCode = 10;	
	}
	return this.iErrorCode;
}

/*
--         iX,iY  iW,  iH  
--   Parameters:
--				iX	 			- X    
--				iY 			- Y    
--				iW	 			-  
--				iH 			-  
------------------
--   return iErrorCode. 0 -   ,11 -    
-- 
*/

method uint PPDF.DrawRect(uint iX,uint iY,uint iW,uint iH)
{
  this.iErrorCode = 0;
  if (PPDF_EmitRect(this.PPDFFILE,iX,iY,iW,iH) < 0)
	{
	  this.iErrorCode = 11;	
	}
	return this.iErrorCode;
}

/*
--          iX,iY  iR  
--   Parameters:
--				iX	 			- X    
--				iY 			- Y    
--				iR	 			-  
------------------
--   return iErrorCode. 0 -  ,12 -    
-- 
*/

method uint PPDF.DrawCircle(uint iX,uint iY,uint iR)
{
  this.iErrorCode = 0;
  if (PPDF_EmitCircle(this.PPDFFILE,iX,iY,iR) < 0)
	{
	  this.iErrorCode = 12;	
	}
	return this.iErrorCode;
}

/*
--      iW  
--   Parameters:
--				iW	 			-  
------------------
--   return iErrorCode. 0 -  ,13 -    
-- 
*/

method uint PPDF.LineWidth(uint iW)
{
  this.iErrorCode = 0;
  if (PPDF_EmitLineWidth(this.PPDFFILE,iW) < 0)
	{
	  this.iErrorCode = 13;	
	}
	return this.iErrorCode;
}
